/****************************************************************************
**
** Copyright (C) 1992-2009 Nokia. All rights reserved.
**
** This file is part of Qt Jambi.
**
** $BEGIN_LICENSE$
** GNU Lesser General Public License Usage
** This file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Nokia gives you certain
** additional rights. These rights are described in the Nokia Qt LGPL
** Exception version 1.0, included in the file LGPL_EXCEPTION.txt in this
** package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3.0 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU General Public License version 3.0 requirements will be
** met: http://www.gnu.org/copyleft/gpl.html.
** $END_LICENSE$

**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

package com.trolltech.tests;

import com.trolltech.qt.gui.*;
import java.awt.event.*;
import javax.swing.*;


class SwingWindow extends JFrame implements ActionListener
{
    private static final long serialVersionUID = 1L;

    public SwingWindow()
    {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setDefaultLookAndFeelDecorated(true);

        JButton button = new JButton("Hit me");
        button.setActionCommand("hit");
        button.addActionListener(this);
        add(button);

        pack();

    }

    public void actionPerformed(ActionEvent e)
    {
        if (e.getActionCommand().equals("hit")) {
            QtWindow w = new QtWindow();
            w.show();
        }
    }
}

class QtWindow extends QPushButton
{
    public QtWindow()
    {
        super("Hit me");

        clicked.connect(this, "openSwingWindow()");
    }

    public void openSwingWindow()
    {
        SwingWindow w = new SwingWindow();
        w.setVisible(true);
    }
}

public class SwingQt extends QPushButton{



    /**
     * @param args
     */
    public static void main(String[] args) {
        new QApplication(args);
        QtWindow w = new QtWindow();
        w.show();

        QApplication.execStatic();
        QApplication.shutdown();
    }

}
